/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2011 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.ui.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.fortiss.tooling.kernel.extension.data.Prototype;
import org.fortiss.tooling.kernel.ui.dnd.ElementCompositionSource;

/**
 * Utility methods for drag and drop support.
 * 
 * @author hoelzl
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating GREEN Hash: 0F0AF0D341A10ADF63D45D05A45E5D7E
 */
public final class DragAndDropUtils {

	/** Extracts the EObject contained in the given drop object. */
	public static EObject extractDroppedEObject(Object data) {
		// if the dropped object is a selection, extract content
		if (data instanceof IStructuredSelection
				&& !((IStructuredSelection) data).isEmpty()) {
			data = ((IStructuredSelection) data).getFirstElement();
		}

		if (data instanceof Prototype) {
			// create copy of prototype
			return ((Prototype) data).getPrototypeCopy();
		}
		if (data instanceof EObject) {
			return (EObject) data;
		}
		if (data instanceof ElementCompositionSource) {
			return ((ElementCompositionSource) data).getDesignatedElement();
		}
		return null;
	}
}
